class ConsultingPostsCarousel extends elementorModules.frontend.handlers.Base {
    onInit() {
        let $ = jQuery;
        var containers = $('.consulting-posts-carousel-wrapper');
        $.each( containers, function(container) {
            if (! $(this).hasClass('slick-slider')) {

                var id = $(this).data('id');
                var posts_carousel = $(".consulting-posts-carousel-wrapper[data-id=" + id + "]");
                var columns = $(this).data('columns');
                var slickRtl = false;
                var centerMode = false;
                var infinite = false;
                var navigation = false;
                var pagination = false;
                var autoplay = false;
                var autoplay_speed = $(this).data('autoplay-speed');
                var lazyload = '';
                var pause_hover = false;
                var pause_interaction = false;

                if ($('body').hasClass('rtl')) {
                    slickRtl = true;
                }
                if ($(this).data('navigation') == 'yes') {
                    navigation = true;
                }
                if ($(this).data('pagination') == 'yes') {
                    pagination = true;
                }
                if ($(this).data('autoplay') == 'yes') {
                    autoplay = true;
                }
                if ($(this).data('lazyload') == 'yes') {
                    lazyload = 'ondemand';
                }
                if ($(this).data('pause-hover') == 'yes') {
                    pause_hover = true;
                }
                if ($(this).data('pause-interaction') == 'yes') {
                    pause_interaction = true;
                }
                if ($(this).data('infinite') == 'yes') {
                    infinite = true;
                }
                if ($(this).data('type') == 'full_width') {
                    centerMode = true;
                    infinite = true;
                }

                if (window.innerWidth <= 768) {
                    centerMode = false;
                }

                if (posts_carousel.parent().hasClass('list') || posts_carousel.parent().hasClass('side_image')) {
                    centerMode = false;
                }

                $(posts_carousel).slick({
                    rtl: slickRtl,
                    dots: pagination,
                    infinite: infinite,
                    arrows: navigation,
                    prevArrow: '',
                    nextArrow: '',
                    autoplaySpeed: autoplay_speed,
                    autoplay: autoplay,
                    slidesToShow: columns,
                    centerMode: centerMode,
                    lazyLoad: lazyload,
                    pauseOnHover: pause_hover,
                    pauseOnInteraction: pause_interaction,
                    cssEase: "linear",
                    slidesToScroll: 1,
                    responsive: [
                        {
                            breakpoint: 991,
                            settings: {
                                slidesToShow: 2,
                            }
                        },
                        {
                            breakpoint: 680,
                            settings: {
                                slidesToShow: 1,
                            }
                        }
                    ]
                });
                posts_carousel.next('.consulting-posts-carousel-nav').find('.slick-prev-extra').on('click', function () {
                    posts_carousel.slick('slickPrev');
                });
                posts_carousel.next('.consulting-posts-carousel-nav').find('.slick-next-extra').on('click', function () {
                    posts_carousel.slick('slickNext');
                });
            }
        });

    }
}

jQuery(window).on('elementor/frontend/init', () => {
    const addHandler = ($element) => {
        elementorFrontend.elementsHandler.addHandler(ConsultingPostsCarousel, {
            $element,
        });
    };
    elementorFrontend.hooks.addAction('frontend/element_ready/stm_posts_carousel.default', addHandler);
});