<?php

use Elementor\Controls_Manager;
use Elementor\Core\Kits\Documents\Tabs\Global_Typography;
use Elementor\Group_Control_Typography;
use Elementor\Group_Control_Box_Shadow;

class Elementor_STM_Posts_Carousel extends \Elementor\Widget_Base {
	public function __construct( $data = array(), $args = null ) {
		parent::__construct( $data, $args );
		wp_register_style( 'consulting-posts-general', CONSULTING_ELEMENTOR_URL . 'assets/css/widgets/posts-carousel/general.css', array(), CONSULTING_ELEMENTOR_VERSION, false );
		wp_register_style( 'consulting-posts-carousel-grid', CONSULTING_ELEMENTOR_URL . 'assets/css/widgets/posts-carousel/grid.css', array(), CONSULTING_ELEMENTOR_VERSION, false );
		wp_register_style( 'consulting-posts-carousel-date-boxed', CONSULTING_ELEMENTOR_URL . 'assets/css/widgets/posts-carousel/date_boxed.css', array(), CONSULTING_ELEMENTOR_VERSION, false );
		wp_register_style( 'consulting-posts-carousel-date-boxed-2', CONSULTING_ELEMENTOR_URL . 'assets/css/widgets/posts-carousel/date_boxed_2.css', array(), CONSULTING_ELEMENTOR_VERSION, false );
		wp_register_style( 'consulting-posts-carousel-side-image', CONSULTING_ELEMENTOR_URL . 'assets/css/widgets/posts-carousel/side_image.css', array(), CONSULTING_ELEMENTOR_VERSION, false );
		wp_register_style( 'consulting-posts-carousel-list', CONSULTING_ELEMENTOR_URL . 'assets/css/widgets/posts-carousel/list.css', array(), CONSULTING_ELEMENTOR_VERSION, false );
		wp_register_style( 'consulting-posts-carousel-full-image', CONSULTING_ELEMENTOR_URL . 'assets/css/widgets/posts-carousel/full_image.css', array(), CONSULTING_ELEMENTOR_VERSION, false );
		wp_register_style( 'consulting-posts-carousel-overlay-image', CONSULTING_ELEMENTOR_URL . 'assets/css/widgets/posts-carousel/overlay_image.css', array(), CONSULTING_ELEMENTOR_VERSION, false );
		wp_register_style( 'consulting-posts-carousel-minimalistic', CONSULTING_ELEMENTOR_URL . 'assets/css/widgets/posts-carousel/minimalistic.css', array(), CONSULTING_ELEMENTOR_VERSION, false );
		wp_register_script( 'consulting-posts-carousel', CONSULTING_ELEMENTOR_URL . 'assets/js/widgets/posts-carousel.js', array( 'elementor-frontend' ), CONSULTING_ELEMENTOR_VERSION, true );
	}
	public function get_name() {
		return 'stm_posts_carousel';
	}
	public function get_title() {
		return esc_html__( 'Posts Carousel', 'consulting-elementor-widgets' );
	}
	public function get_icon() {
		return 'consulting-eicon-posts-carousel';
	}
	public function get_categories() {
		return array( 'consulting-widgets' );
	}
	public function get_script_depends() {
		return array(
			'slick',
			'consulting-posts-carousel',
		);
	}
	public function get_style_depends() {
		return array(
			'slick',
			'consulting-posts-general',
			'consulting-posts-carousel-grid',
			'consulting-posts-carousel-date-boxed',
			'consulting-posts-carousel-date-boxed-2',
			'consulting-posts-carousel-side-image',
			'consulting-posts-carousel-list',
			'consulting-posts-carousel-full-image',
			'consulting-posts-carousel-overlay-image',
			'consulting-posts-carousel-minimalistic',
		);
	}

	public function add_dimensions( $selector = '' ) {
		$this->start_controls_section(
			'section_dimensions',
			array(
				'label' => __( 'Dimensions', 'consulting-elementor-widgets' ),
			)
		);

		$this->add_responsive_control(
			'margin',
			array(
				'label'      => __( 'Margin', 'consulting-elementor-widgets' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em' ),
				'selectors'  => array(
					"{{WRAPPER}} {$selector}" => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'padding',
			array(
				'label'      => __( 'Padding', 'consulting-elementor-widgets' ),
				'type'       => Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em' ),
				'selectors'  => array(
					"{{WRAPPER}} {$selector}" => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->end_controls_section();
	}

	protected function register_controls() {
		$this->start_controls_section(
			'content_section',
			array(
				'label' => __( 'General', 'consulting-elementor-widgets' ),
				'tab'   => \Elementor\Controls_Manager::TAB_CONTENT,
			)
		);

		$this->add_control(
			'posts_style',
			array(
				'label'   => __( 'Style', 'consulting-elementor-widgets' ),
				'type'    => \Elementor\Controls_Manager::SELECT,
				'default' => 'grid',
				'options' => array(
					'grid'          => __( 'Grid', 'consulting-elementor-widgets' ),
					'date_boxed'    => __( 'Date Boxed', 'consulting-elementor-widgets' ),
					'date_boxed_2'  => __( 'Date Boxed 2', 'consulting-elementor-widgets' ),
					'side_image'    => __( 'Side Image', 'consulting-elementor-widgets' ),
					'list'          => __( 'List', 'consulting-elementor-widgets' ),
					'full_image'    => __( 'Full Image', 'consulting-elementor-widgets' ),
					'overlay_image' => __( 'Overlay Image', 'consulting-elementor-widgets' ),
					'minimalistic'  => __( 'Minimalistic', 'consulting-elementor-widgets' ),
				),
			)
		);

		$this->add_control(
			'carousel_type',
			array(
				'label'   => __( 'Carousel Type', 'consulting-elementor-widgets' ),
				'type'    => \Elementor\Controls_Manager::SELECT,
				'default' => 'default',
				'options' => array(
					'default'    => __( 'Default', 'consulting-elementor-widgets' ),
					'full_width' => __( 'Full Width', 'consulting-elementor-widgets' ),
				),
			)
		);

		$this->add_control(
			'full_width_no_spacing',
			array(
				'label'        => __( 'No Spacing', 'consulting-elementor-widgets' ),
				'type'         => \Elementor\Controls_Manager::SWITCHER,
				'label_on'     => __( 'Yes', 'consulting-elementor-widgets' ),
				'label_off'    => __( 'No', 'consulting-elementor-widgets' ),
				'return_value' => 'yes',
				'default'      => 'no',
				'condition'    => array(
					'posts_style'   => 'full_image',
					'carousel_type' => 'full_width',
				),
			)
		);

		$this->add_control(
			'posts_per_row',
			array(
				'label'       => __( 'Posts Per Row', 'consulting-elementor-widgets' ),
				'type'        => \Elementor\Controls_Manager::SELECT,
				'default'     => 3,
				'options'     => array(
					2 => 2,
					3 => 3,
				),
				'description' => __( 'Note: Some styles are adapted to the section for 3 columns', 'consulting-elementor-widgets' ),
				'condition'   => array(
					'posts_style' => array( 'grid', 'date_boxed', 'date_boxed_2', 'full_image', 'overlay_image', 'minimalistic' ),
				),
			)
		);

		$this->add_control(
			'posts_per_row_2',
			array(
				'label'       => __( 'Posts Per Row', 'consulting-elementor-widgets' ),
				'type'        => \Elementor\Controls_Manager::SELECT,
				'default'     => 2,
				'options'     => array(
					2 => 2,
				),
				'description' => __( 'Note: Some styles are adapted to the section for 2 columns', 'consulting-elementor-widgets' ),
				'condition'   => array(
					'posts_style' => array( 'side_image' ),
				),
			)
		);

		$this->add_control(
			'posts_per_row_3',
			array(
				'label'       => __( 'Posts Per Row', 'consulting-elementor-widgets' ),
				'type'        => \Elementor\Controls_Manager::SELECT,
				'default'     => 1,
				'options'     => array(
					1 => 1,
				),
				'description' => __( 'Note: Some styles are adapted to the section for 1 column', 'consulting-elementor-widgets' ),
				'condition'   => array(
					'posts_style' => array( 'list' ),
				),
			)
		);

		$this->add_control(
			'show_image',
			array(
				'label'        => __( 'Image', 'consulting-elementor-widgets' ),
				'type'         => \Elementor\Controls_Manager::SWITCHER,
				'label_on'     => __( 'Show', 'consulting-elementor-widgets' ),
				'label_off'    => __( 'Hide', 'consulting-elementor-widgets' ),
				'default'      => 'show',
				'return_value' => 'show',
			)
		);

		$this->add_control(
			'show_category',
			array(
				'label'        => __( 'Category', 'consulting-elementor-widgets' ),
				'type'         => \Elementor\Controls_Manager::SWITCHER,
				'label_on'     => __( 'Show', 'consulting-elementor-widgets' ),
				'label_off'    => __( 'Hide', 'consulting-elementor-widgets' ),
				'default'      => 'show',
				'return_value' => 'show',
			)
		);

		$this->add_control(
			'show_excerpt',
			array(
				'label'        => __( 'Excerpt', 'consulting-elementor-widgets' ),
				'type'         => \Elementor\Controls_Manager::SWITCHER,
				'label_on'     => __( 'Show', 'consulting-elementor-widgets' ),
				'label_off'    => __( 'Hide', 'consulting-elementor-widgets' ),
				'default'      => 'show',
				'return_value' => 'show',
				'condition'    => array(
					'posts_style!' => array( 'side_image', 'full_image', 'overlay_image' ),
				),
			)
		);

		$this->add_control(
			'excerpt_length',
			array(
				'label'        => __( 'Excerpt Length', 'consulting-elementor-widgets' ),
				'type'         => \Elementor\Controls_Manager::TEXT,
				'placeholder' => __( 'e.g. 160', 'consulting-elementor-widgets' ),
				'description' => __( 'Trims text to a certain number of symbols', 'consulting-elementor-widgets' ),
				'condition'    => array(
					'show_excerpt' => 'show',
					'posts_style!' => array( 'side_image', 'full_image', 'overlay_image' ),
				),
			)
		);

		$this->add_control(
			'show_date',
			array(
				'label'        => __( 'Date', 'consulting-elementor-widgets' ),
				'type'         => \Elementor\Controls_Manager::SWITCHER,
				'label_on'     => __( 'Show', 'consulting-elementor-widgets' ),
				'label_off'    => __( 'Hide', 'consulting-elementor-widgets' ),
				'default'      => 'show',
				'return_value' => 'show',
			)
		);

		$this->add_control(
			'show_title_line',
			array(
				'label'     => __( 'Title Line', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'default'   => 'under_title',
				'options'   => array(
					'none'        => __( 'No', 'consulting-elementor-widgets' ),
					'above_title' => __( 'Above Title', 'consulting-elementor-widgets' ),
					'under_title' => __( 'Under Title', 'consulting-elementor-widgets' ),
				),
				'condition' => array(
					'posts_style' => array( 'grid', 'side_image', 'list', 'minimalistic' ),
				),
			)
		);

		$this->add_control(
			'show_button',
			array(
				'label'        => __( 'Link Button', 'consulting-elementor-widgets' ),
				'type'         => \Elementor\Controls_Manager::SWITCHER,
				'label_on'     => __( 'Show', 'consulting-elementor-widgets' ),
				'label_off'    => __( 'Hide', 'consulting-elementor-widgets' ),
				'default'      => 'show',
				'return_value' => 'show',
			)
		);

		$this->add_control(
			'button_text',
			array(
				'label'     => __( 'Put Button Text', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::TEXT,
				'default'   => __( 'Read More', 'consulting-elementor-widgets' ),
				'condition' => array(
					'show_button' => 'show',
				),
			)
		);

		$this->end_controls_section();

		Consulting_Elementor_Widgets::add_query_builder( $this, 'qb' );

		$this->start_controls_section(
			'carousel_section',
			array(
				'label' => __( 'Carousel Settings', 'consulting-elementor-widgets' ),
				'tab'   => \Elementor\Controls_Manager::TAB_CONTENT,
			)
		);

		$this->add_control(
			'show_navigation',
			array(
				'label'        => __( 'Show Navigation', 'consulting-elementor-widgets' ),
				'type'         => \Elementor\Controls_Manager::SWITCHER,
				'label_on'     => __( 'Yes', 'consulting-elementor-widgets' ),
				'label_off'    => __( 'No', 'consulting-elementor-widgets' ),
				'default'      => 'yes',
				'return_value' => 'yes',
			)
		);

		$this->add_control(
			'navigation_position',
			array(
				'label'     => __( 'Navigation Position', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'default'   => 'separate',
				'options'   => array(
					'separate' => __( 'Separate', 'consulting-elementor-widgets' ),
					'together' => __( 'Together', 'consulting-elementor-widgets' ),
				),
				'condition' => array(
					'show_navigation' => 'yes',
				),
			)
		);

		$this->add_control(
			'navigation_horizontal_offset',
			array(
				'label'      => __( 'Navigation Horizontal Offset', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'em', 'rem', 'custom' ),
				'range'      => array(
					'px'  => array(
						'min'  => 0,
						'max'  => 200,
						'step' => 1,
					),
					'em'  => array(
						'min' => 0,
						'max' => 100,
					),
					'rem' => array(
						'min' => 0,
						'max' => 100,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav .slick-prev'   => 'left: -{{SIZE}}{{UNIT}};',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav .slick-next'   => 'right: -{{SIZE}}{{UNIT}};',
				),
				'default'    => array(
					'size' => 80,
					'unit' => 'px',
				),
				'condition'  => array(
					'show_navigation'     => 'yes',
					'navigation_position' => 'separate',
				),
			)
		);

		$this->add_control(
			'navigation_together_vertical_position',
			array(
				'label'     => __( 'Navigation Vertical Position', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::CHOOSE,
				'options'   => array(
					'top'    => array(
						'title' => __( 'Top', 'consulting-elementor-widgets' ),
						'icon'  => 'fas fa-arrow-up',
					),
					'bottom' => array(
						'title' => __( 'Bottom', 'consulting-elementor-widgets' ),
						'icon'  => 'fa fa-arrow-down',
					),
				),
				'default'   => 'top',
				'condition' => array(
					'show_navigation'     => 'yes',
					'navigation_position' => 'together',
				),
			)
		);

		$this->add_control(
			'navigation_together_horizontal_position',
			array(
				'label'     => __( 'Navigation Horizontal Position', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::CHOOSE,
				'options'   => array(
					'left'   => array(
						'title' => __( 'Left', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-left',
					),
					'center' => array(
						'title' => __( 'Center', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-center',
					),
					'right'  => array(
						'title' => __( 'Right', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-right',
					),
				),
				'default'   => 'left',
				'condition' => array(
					'show_navigation'     => 'yes',
					'navigation_position' => 'together',
				),
			)
		);

		$this->add_control(
			'navigation_vertical_offset',
			array(
				'label'      => __( 'Navigation Vertical Offset', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'em', 'rem' ),
				'range'      => array(
					'px'  => array(
						'min'  => 0,
						'max'  => 200,
						'step' => 1,
					),
					'em'  => array(
						'min' => 0,
						'max' => 100,
					),
					'rem' => array(
						'min' => 0,
						'max' => 100,
					),
				),
				'default'    => array(
					'size' => 50,
					'unit' => 'px',
				),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel.navigation-position-together.navigation-together-vertical-position-top .consulting-posts-carousel-nav' => 'margin-bottom: {{SIZE}}{{UNIT}};',
					'{{WRAPPER}} .consulting-posts-carousel.navigation-position-together.navigation-together-vertical-position-bottom .consulting-posts-carousel-nav' => 'margin-top: {{SIZE}}{{UNIT}};',
				),
				'condition'  => array(
					'show_navigation'     => 'yes',
					'navigation_position' => 'together',
				),
			)
		);

		$this->add_control(
			'navigation_space_between',
			array(
				'label'      => __( 'Navigation Space Between', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'em', 'rem', 'custom' ),
				'range'      => array(
					'px'  => array(
						'min'  => 0,
						'max'  => 1000,
						'step' => 1,
					),
					'em'  => array(
						'min' => 0,
						'max' => 100,
					),
					'rem' => array(
						'min' => 0,
						'max' => 100,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav' => 'gap: {{SIZE}}{{UNIT}};',
				),
				'default'    => array(
					'size' => 10,
					'unit' => 'px',
				),
				'condition'  => array(
					'show_navigation'     => 'yes',
					'navigation_position' => 'together',
				),
			)
		);

		$this->add_control(
			'show_pagination',
			array(
				'label'        => __( 'Show Pagination', 'consulting-elementor-widgets' ),
				'type'         => \Elementor\Controls_Manager::SWITCHER,
				'label_on'     => __( 'Yes', 'consulting-elementor-widgets' ),
				'label_off'    => __( 'No', 'consulting-elementor-widgets' ),
				'default'      => 'yes',
				'return_value' => 'yes',
			)
		);

		$this->add_control(
			'pagination_alignment',
			array(
				'label'     => __( 'Pagination Alignment', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::CHOOSE,
				'options'   => array(
					'left'   => array(
						'title' => __( 'Left', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-left',
					),
					'center' => array(
						'title' => __( 'Center', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-center',
					),
					'right'  => array(
						'title' => __( 'Right', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-right',
					),
				),
				'default'   => 'center',
				'condition' => array(
					'show_pagination' => 'yes',
				),
			)
		);

		$this->add_control(
			'pagination_vertical_offset',
			array(
				'label'      => __( 'Pagination Vertical Offset', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'em', 'rem', 'custom' ),
				'range'      => array(
					'px'  => array(
						'min'  => 0,
						'max'  => 200,
						'step' => 1,
					),
					'em'  => array(
						'min' => 0,
						'max' => 100,
					),
					'rem' => array(
						'min' => 0,
						'max' => 100,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .slick-dots'   => 'margin-top: {{SIZE}}{{UNIT}};',
				),
				'default'    => array(
					'size' => 50,
					'unit' => 'px',
				),
				'condition'  => array(
					'show_pagination' => 'yes',
				),
			)
		);

		$this->add_control(
			'pagination_space_between_bullets',
			array(
				'label'      => __( 'Space Between Bullets', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'custom' ),
				'range'      => array(
					'px'  => array(
						'min'  => 0,
						'max'  => 100,
						'step' => 1,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .slick-dots' => 'gap: {{SIZE}}{{UNIT}};',
				),
				'default'    => array(
					'size' => 10,
					'unit' => 'px',
				),
				'condition'  => array(
					'show_pagination' => 'yes',
				),
			)
		);

		$this->add_control(
			'carousel_lazyload',
			array(
				'label'              => esc_html__( 'Lazyload', 'consulting-elementor-widgets' ),
				'type'               => Controls_Manager::SWITCHER,
				'frontend_available' => true,
				'label_on'           => __( 'Yes', 'consulting-elementor-widgets' ),
				'label_off'          => __( 'No', 'consulting-elementor-widgets' ),
				'default'            => '',
				'return_value'       => 'yes',
			)
		);

		$this->add_control(
			'carousel_autoplay',
			array(
				'label'        => __( 'Autoplay', 'consulting-elementor-widgets' ),
				'type'         => \Elementor\Controls_Manager::SWITCHER,
				'label_on'     => __( 'Yes', 'consulting-elementor-widgets' ),
				'label_off'    => __( 'No', 'consulting-elementor-widgets' ),
				'default'      => '',
				'return_value' => 'yes',
			)
		);

		$this->add_control(
			'carousel_pause_on_hover',
			array(
				'label'              => esc_html__( 'Pause on Hover', 'consulting-elementor-widgets' ),
				'type'               => Controls_Manager::SWITCHER,
				'label_on'           => esc_html__( 'Yes', 'consulting-elementor-widgets' ),
				'label_off'          => esc_html__( 'No', 'consulting-elementor-widgets' ),
				'return_value'       => 'yes',
				'default'            => 'yes',
				'condition'          => array(
					'carousel_autoplay' => 'yes',
				),
				'render_type'        => 'none',
				'frontend_available' => true,
			)
		);

		$this->add_control(
			'carousel_pause_on_interaction',
			array(
				'label'              => esc_html__( 'Pause on Interaction', 'consulting-elementor-widgets' ),
				'type'               => Controls_Manager::SWITCHER,
				'label_on'           => esc_html__( 'Yes', 'consulting-elementor-widgets' ),
				'label_off'          => esc_html__( 'No', 'consulting-elementor-widgets' ),
				'return_value'       => 'yes',
				'default'            => 'yes',
				'condition'          => array(
					'carousel_autoplay' => 'yes',
				),
				'frontend_available' => true,
			)
		);

		$this->add_control(
			'carousel_autoplay_speed',
			array(
				'label'              => __( 'Autoplay Speed', 'consulting-elementor-widgets' ),
				'type'               => Controls_Manager::NUMBER,
				'default'            => 5000,
				'condition'          => array(
					'carousel_autoplay' => 'yes',
				),
				'render_type'        => 'none',
				'frontend_available' => true,
			)
		);

		$this->add_control(
			'carousel_infinite',
			array(
				'label'              => esc_html__( 'Infinite Loop', 'consulting-elementor-widgets' ),
				'type'               => Controls_Manager::SWITCHER,
				'label_on'           => esc_html__( 'Yes', 'consulting-elementor-widgets' ),
				'label_off'          => esc_html__( 'No', 'consulting-elementor-widgets' ),
				'return_value'       => 'yes',
				'default'            => 'no',
				'frontend_available' => true,
			)
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'text_section',
			array(
				'label' => __( 'Text', 'consulting-elementor-widgets' ),
				'tab'   => Controls_Manager::TAB_STYLE,
			)
		);

		$this->add_control(
			'title_color',
			array(
				'label'     => __( 'Title Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-title a' => 'color: {{VALUE}}',
				),
			)
		);

		$this->add_control(
			'title_hover_color',
			array(
				'label'     => __( 'Title Hover Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item:hover .posts-item-title a' => 'color: {{VALUE}}',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'title_typography',
				'label'    => __( 'Title Typography', 'consulting-elementor-widgets' ),
				'selector' => '{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-title',
				'global'   => array(
					'default' => Global_Typography::TYPOGRAPHY_TEXT,
				),
			)
		);

		$this->add_control(
			'title_alignment_left',
			array(
				'label'     => __( 'Title Alignment', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::CHOOSE,
				'options'   => array(
					'left'   => array(
						'title' => __( 'Left', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-left',
					),
					'center' => array(
						'title' => __( 'Center', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-center',
					),
					'right'  => array(
						'title' => __( 'Right', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-right',
					),
				),
				'default'   => 'left',
				'condition' => array(
					'posts_style!' => array( 'date_boxed_2' ),
				),
			)
		);

		$this->add_control(
			'title_alignment_center',
			array(
				'label'     => __( 'Title Alignment', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::CHOOSE,
				'options'   => array(
					'left'   => array(
						'title' => __( 'Left', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-left',
					),
					'center' => array(
						'title' => __( 'Center', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-center',
					),
					'right'  => array(
						'title' => __( 'Right', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-right',
					),
				),
				'default'   => 'center',
				'condition' => array(
					'posts_style' => array( 'date_boxed_2' ),
				),
			)
		);

		$this->add_responsive_control(
			'title_margin',
			array(
				'label'      => __( 'Title Margin', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-title' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
				'separator'  => 'after',
			)
		);

		$this->add_control(
			'category_color',
			array(
				'label'     => __( 'Category Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-category a' => 'color: {{VALUE}}',
				),
				'condition' => array(
					'show_category' => 'show',
				),
			)
		);

		$this->add_control(
			'category_hover_color',
			array(
				'label'     => __( 'Category Hover Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item:hover .posts-item-category a' => 'color: {{VALUE}}',
				),
				'condition' => array(
					'show_category' => 'show',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'      => 'category_typography',
				'label'     => __( 'Category Typography', 'consulting-elementor-widgets' ),
				'selector'  => '{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-category',
				'global'    => array(
					'default' => Global_Typography::TYPOGRAPHY_TEXT,
				),
				'condition' => array(
					'show_category' => 'show',
				),
			)
		);

		$this->add_control(
			'category_alignment_left',
			array(
				'label'     => __( 'Category Alignment', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::CHOOSE,
				'options'   => array(
					'left'   => array(
						'title' => __( 'Left', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-left',
					),
					'center' => array(
						'title' => __( 'Center', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-center',
					),
					'right'  => array(
						'title' => __( 'Right', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-right',
					),
				),
				'default'   => 'left',
				'condition' => array(
					'show_category' => 'show',
					'posts_style!'  => array( 'date_boxed_2', 'list', 'full_image' ),
				),
			)
		);

		$this->add_control(
			'category_alignment_center',
			array(
				'label'     => __( 'Category Alignment', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::CHOOSE,
				'options'   => array(
					'left'   => array(
						'title' => __( 'Left', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-left',
					),
					'center' => array(
						'title' => __( 'Center', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-center',
					),
					'right'  => array(
						'title' => __( 'Right', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-right',
					),
				),
				'default'   => 'center',
				'condition' => array(
					'show_category' => 'show',
					'posts_style'   => array( 'date_boxed_2' ),
				),
			)
		);

		$this->add_responsive_control(
			'category_margin',
			array(
				'label'      => __( 'Category Margin', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-category' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
				'condition'  => array(
					'show_category' => 'show',
				),
			)
		);

		$this->add_control(
			'excerpt_color',
			array(
				'label'     => __( 'Excerpt Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-excerpt' => 'color: {{VALUE}}',
				),
				'condition' => array(
					'show_excerpt' => 'show',
					'posts_style!' => array( 'side_image', 'full_image', 'overlay_image' ),
				),
			)
		);

		$this->add_control(
			'excerpt_hover_color',
			array(
				'label'     => __( 'Excerpt Hover Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item:hover .posts-item-excerpt' => 'color: {{VALUE}}',
				),
				'condition' => array(
					'show_excerpt' => 'show',
					'posts_style!' => array( 'side_image', 'full_image', 'overlay_image' ),
				),
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'      => 'excerpt_typography',
				'label'     => __( 'Excerpt Typography', 'consulting-elementor-widgets' ),
				'selector'  => '{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-excerpt',
				'global'    => array(
					'default' => Global_Typography::TYPOGRAPHY_TEXT,
				),
				'condition' => array(
					'show_excerpt' => 'show',
					'posts_style!' => array( 'side_image', 'full_image', 'overlay_image' ),
				),
			)
		);

		$this->add_control(
			'excerpt_alignment_left',
			array(
				'label'     => __( 'Excerpt Alignment', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::CHOOSE,
				'options'   => array(
					'left'   => array(
						'title' => __( 'Left', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-left',
					),
					'center' => array(
						'title' => __( 'Center', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-center',
					),
					'right'  => array(
						'title' => __( 'Right', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-right',
					),
				),
				'default'   => 'left',
				'condition' => array(
					'show_excerpt' => 'show',
					'posts_style!' => array( 'date_boxed_2', 'side_image', 'full_image', 'overlay_image' ),
				),
			)
		);

		$this->add_control(
			'excerpt_alignment_center',
			array(
				'label'     => __( 'Excerpt Alignment', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::CHOOSE,
				'options'   => array(
					'left'   => array(
						'title' => __( 'Left', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-left',
					),
					'center' => array(
						'title' => __( 'Center', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-center',
					),
					'right'  => array(
						'title' => __( 'Right', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-right',
					),
				),
				'default'   => 'center',
				'condition' => array(
					'show_excerpt' => 'show',
					'posts_style'  => array( 'date_boxed_2' ),
				),
			)
		);

		$this->add_responsive_control(
			'excerpt_margin',
			array(
				'label'      => __( 'Excerpt Margin', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-excerpt' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
				'separator'  => 'after',
				'condition'  => array(
					'show_excerpt' => 'show',
					'posts_style!' => array( 'side_image', 'full_image', 'overlay_image' ),
				),
			)
		);

		$this->add_control(
			'bottom_alignment',
			array(
				'label'     => __( 'Bottom Info Alignment', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::CHOOSE,
				'options'   => array(
					'left'   => array(
						'title' => __( 'Left', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-left',
					),
					'center' => array(
						'title' => __( 'Center', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-center',
					),
					'right'  => array(
						'title' => __( 'Right', 'consulting-elementor-widgets' ),
						'icon'  => 'eicon-text-align-right',
					),
				),
				'default'   => 'left',
				'condition' => array(
					'posts_style' => array( 'list' ),
				),
			)
		);

		$this->add_responsive_control(
			'bottom_info_spacing',
			array(
				'label'      => __( 'Bottom Info Spacing', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'em', 'rem', 'custom' ),
				'range'      => array(
					'px'  => array(
						'min'  => 0,
						'max'  => 200,
						'step' => 1,
					),
					'em'  => array(
						'min' => 0,
						'max' => 200,
					),
					'rem' => array(
						'min' => 0,
						'max' => 200,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel.list .consulting-posts-carousel-wrapper .posts-item .posts-item-inner .posts-item-bottom' => 'gap: {{SIZE}}{{UNIT}};',
				),
				'condition'  => array(
					'posts_style' => array( 'list' ),
				),
			)
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'title_line_section',
			array(
				'label'     => __( 'Title Line', 'consulting-elementor-widgets' ),
				'tab'       => Controls_Manager::TAB_STYLE,
				'condition' => array(
					'show_title_line!' => 'none',
				),
			)
		);

		$this->add_control(
			'title_line_color',
			array(
				'label'     => __( 'Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-title:after'  => 'background-color: {{VALUE}}',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-title:before' => 'background-color: {{VALUE}}',
				),
			)
		);

		$this->add_control(
			'title_line_hover_color',
			array(
				'label'     => __( 'Hover Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item:hover .posts-item-title:after'  => 'background-color: {{VALUE}}',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item:hover .posts-item-title:before' => 'background-color: {{VALUE}}',
				),
			)
		);

		$this->add_control(
			'title_line_width',
			array(
				'label'     => __( 'Width (px)', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::NUMBER,
				'default'   => 60,
				'min'       => 0,
				'max'       => 300,
				'step'      => 1,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-title:after'  => 'width: {{VALUE}}px',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-title:before' => 'width: {{VALUE}}px',
				),
			)
		);

		$this->add_control(
			'title_line_height',
			array(
				'label'     => __( 'Height (px)', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::NUMBER,
				'default'   => 4,
				'min'       => 0,
				'max'       => 300,
				'step'      => 1,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-title:after'  => 'height: {{VALUE}}px',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-title:before' => 'height: {{VALUE}}px',
				),
			)
		);

		$this->add_responsive_control(
			'title_line_border_radius',
			array(
				'label'      => __( 'Border Radius', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-title:before' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-title:after' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'title_line_margin_top',
			array(
				'label'     => __( 'Margin Top (px)', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::NUMBER,
				'min'       => -100,
				'max'       => 100,
				'step'      => 1,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-title:after'  => 'margin-top: {{VALUE}}px',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-title:before' => 'margin-top: {{VALUE}}px',
				),
			)
		);

		$this->add_control(
			'title_line_margin_bottom',
			array(
				'label'     => __( 'Margin Bottom (px)', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::NUMBER,
				'min'       => -100,
				'max'       => 100,
				'step'      => 1,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-title:after'  => 'margin-bottom: {{VALUE}}px',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-title:before' => 'margin-bottom: {{VALUE}}px',
				),
			)
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'box_section',
			array(
				'label'     => __( 'Box', 'consulting-elementor-widgets' ),
				'tab'       => Controls_Manager::TAB_STYLE,
				'condition' => array(
					'posts_style!' => array( 'full_image', 'overlay_image' ),
				),
			)
		);

		$this->add_control(
			'box_bg_color',
			array(
				'label'     => __( 'Background Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-info' => 'background-color: {{VALUE}}',
				),
			)
		);

		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			array(
				'name'     => 'box_border',
				'selector' => '{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-info',
			)
		);

		$this->add_control(
			'box_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-inner' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			array(
				'name'           => 'box_box_shadow',
				'selector'       => '{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-inner',
				'fields_options' => array(
					'box_shadow_type' => array(
						'default' => 'yes',
					),
					'box_shadow'      => array(
						'default' => array(
							'horizontal' => 0,
							'vertical'   => 4,
							'blur'       => 40,
							'spread'     => 0,
							'color'      => '#0000000F',
						),
					),
				),
			)
		);

		$this->add_control(
			'box_padding',
			array(
				'label'      => esc_html__( 'Padding', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-info' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
				'separator'  => 'before',
			)
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'link_section',
			array(
				'label'     => __( 'Link Button', 'consulting-elementor-widgets' ),
				'tab'       => Controls_Manager::TAB_STYLE,
				'condition' => array(
					'show_button' => 'show',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'button_typography',
				'label'    => __( 'Typography', 'consulting-elementor-widgets' ),
				'selector' => '{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-button',
				'global'   => array(
					'default' => Global_Typography::TYPOGRAPHY_TEXT,
				),
			)
		);

		$this->add_control(
			'link_button_line_color',
			array(
				'label'     => __( 'Button Line Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-bottom:before' => 'background-color: {{VALUE}}',
				),
				'condition' => array(
					'posts_style' => array( 'date_boxed' ),
				),
			)
		);

		$this->add_control(
			'button_icon',
			array(
				'label'       => esc_html__( 'Icon', 'consulting-elementor-widgets' ),
				'type'        => \Elementor\Controls_Manager::ICONS,
				'skin'        => 'inline',
				'label_block' => false,
				'condition'   => array(
					'posts_style' => array( 'grid', 'minimalistic' ),
				),
				'separator'   => 'before',
			)
		);

		$this->add_control(
			'button_icon_2',
			array(
				'label'       => esc_html__( 'Icon', 'consulting-elementor-widgets' ),
				'type'        => \Elementor\Controls_Manager::ICONS,
				'skin'        => 'inline',
				'label_block' => false,
				'default'     => array(
					'value'   => 'stm-right-arrow',
					'library' => 'stm_library',
				),
				'condition'   => array(
					'posts_style' => array( 'date_boxed', 'date_boxed_2', 'side_image', 'list', 'full_image', 'overlay_image' ),
				),
				'separator'   => 'before',
			)
		);

		$this->add_responsive_control(
			'button_icon_size',
			array(
				'label'      => __( 'Icon Size', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'em', 'rem', 'custom' ),
				'range'      => array(
					'px'  => array(
						'min'  => 0,
						'max'  => 100,
						'step' => 1,
					),
					'em'  => array(
						'min' => 0,
						'max' => 100,
					),
					'rem' => array(
						'min' => 0,
						'max' => 100,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-button i'   => 'font-size: {{SIZE}}{{UNIT}};',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-button svg' => 'width: {{SIZE}}{{UNIT}};height: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'button_icon_position',
			array(
				'label'     => __( 'Icon Position', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'options'   => array(
					'before' => __( 'Before', 'consulting-elementor-widgets' ),
					'after'  => __( 'After', 'consulting-elementor-widgets' ),
				),
				'default'   => 'after',
				'condition' => array(
					'posts_style!' => array( 'overlay_image' ),
				),
			)
		);

		$this->add_control(
			'button_icon_position_2',
			array(
				'label'     => __( 'Icon Position', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::SELECT,
				'options'   => array(
					'before' => __( 'Before', 'consulting-elementor-widgets' ),
					'after'  => __( 'After', 'consulting-elementor-widgets' ),
				),
				'default'   => 'before',
				'condition' => array(
					'posts_style' => array( 'overlay_image' ),
				),
			)
		);

		$this->add_responsive_control(
			'button_icon_spacing',
			array(
				'label'      => __( 'Icon Spacing', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'em', 'rem', 'custom' ),
				'range'      => array(
					'px'  => array(
						'min'  => 0,
						'max'  => 100,
						'step' => 1,
					),
					'em'  => array(
						'min' => 0,
						'max' => 100,
					),
					'rem' => array(
						'min' => 0,
						'max' => 100,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-button' => 'gap: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'icon_padding',
			array(
				'label'      => esc_html__( 'Icon Padding', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-button i'   => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-button svg' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'icon_border_radius',
			array(
				'label'      => esc_html__( 'Icon Border Radius', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-button i'   => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-button svg' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
				'separator'  => 'after',
			)
		);

		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			array(
				'name'     => 'button_border',
				'selector' => '{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-button',
				'exclude'  => array( 'color' ),
			)
		);

		$this->add_control(
			'button_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-button' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_group_control(
			\Elementor\Group_Control_Box_Shadow::get_type(),
			array(
				'name'     => 'button_box_shadow',
				'selector' => '{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-button',
			)
		);

		$this->add_responsive_control(
			'button_padding',
			array(
				'label'      => esc_html__( 'Padding', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-button' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->start_controls_tabs(
			'button_style_tabs'
		);

		$this->start_controls_tab(
			'button_style_normal_tab',
			array(
				'label' => esc_html__( 'Normal', 'consulting-elementor-widgets' ),
			)
		);

		$this->add_control(
			'button_text_color',
			array(
				'label'     => __( 'Text Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-button span' => 'color: {{VALUE}}',
				),
			)
		);

		$this->add_control(
			'button_bg_color',
			array(
				'label'     => __( 'Background Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-button' => 'background-color: {{VALUE}}',
				),
			)
		);

		$this->add_control(
			'button_icon_color',
			array(
				'label'     => __( 'Icon Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-button i'   => 'color: {{VALUE}}',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-button svg' => 'fill: {{VALUE}}',
				),
			)
		);

		$this->add_control(
			'button_icon_bg_color',
			array(
				'label'     => __( 'Icon Background Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-button i'   => 'background-color: {{VALUE}}',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-button svg' => 'background-color: {{VALUE}}',
				),
			)
		);

		$this->add_control(
			'button_icon_border_color',
			array(
				'label'     => __( 'Border Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-button'   => 'border-color: {{VALUE}}',
				),
			)
		);

		$this->end_controls_tab();

		$this->start_controls_tab(
			'button_style_hover_tab',
			array(
				'label' => esc_html__( 'Hover', 'consulting-elementor-widgets' ),
			)
		);

		$this->add_control(
			'button_text_hover_color',
			array(
				'label'     => __( 'Text Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item:hover .posts-item-button span' => 'color: {{VALUE}}',
				),
			)
		);

		$this->add_control(
			'button_bg_hover_color',
			array(
				'label'     => __( 'Background Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item:hover .posts-item-button' => 'background-color: {{VALUE}}',
				),
			)
		);

		$this->add_control(
			'button_icon_hover_color',
			array(
				'label'     => __( 'Icon Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item:hover .posts-item-button i'   => 'color: {{VALUE}}',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item:hover .posts-item-button svg' => 'fill: {{VALUE}}',
				),
			)
		);

		$this->add_control(
			'button_icon_bg_hover_color',
			array(
				'label'     => __( 'Icon Background Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item:hover .posts-item-button i'   => 'background-color: {{VALUE}}',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item:hover .posts-item-button svg' => 'background-color: {{VALUE}}',
				),
			)
		);

		$this->add_control(
			'button_icon_border_hover_color',
			array(
				'label'     => __( 'Border Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item:hover .posts-item-button'   => 'border-color: {{VALUE}}',
				),
			)
		);

		$this->end_controls_tab();

		$this->end_controls_tabs();

		$this->end_controls_section();

		$this->start_controls_section(
			'date_section',
			array(
				'label'     => __( 'Date', 'consulting-elementor-widgets' ),
				'tab'       => Controls_Manager::TAB_STYLE,
				'condition' => array(
					'show_date' => 'show',
				),
			)
		);

		$this->add_group_control(
			Group_Control_Typography::get_type(),
			array(
				'name'     => 'date_typography',
				'label'    => __( 'Typography', 'consulting-elementor-widgets' ),
				'selector' => '{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-date',
				'global'   => array(
					'default' => Global_Typography::TYPOGRAPHY_TEXT,
				),
			)
		);

		$this->add_control(
			'date_color',
			array(
				'label'     => __( 'Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-date' => 'color: {{VALUE}}',
				),
			)
		);

		$this->add_control(
			'date_hover_color',
			array(
				'label'     => __( 'Hover Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item:hover .posts-item-date' => 'color: {{VALUE}}',
				),
			)
		);

		$this->add_control(
			'date_box_bg_color',
			array(
				'label'     => __( 'Background Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-date-wrapper'   => 'background-color: {{VALUE}}',
				),
			)
		);

		$this->add_control(
			'date_box_hover_bg_color',
			array(
				'label'     => __( 'Background Hover Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item:hover .posts-item-date-wrapper' => 'background-color: {{VALUE}}',
				),
			)
		);

		$this->add_responsive_control(
			'date_box_border_radius',
			array(
				'label'      => __( 'Border Radius', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-date-wrapper' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'date_box_padding',
			array(
				'label'      => __( 'Padding', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-date-wrapper' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'datebox_horizontal_position',
			array(
				'label'      => __( 'Date Box Horizontal Position', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'em', 'rem', 'custom' ),
				'range'      => array(
					'px'  => array(
						'min'  => -500,
						'max'  => 500,
						'step' => 1,
					),
					'em'  => array(
						'min' => -100,
						'max' => 100,
					),
					'rem' => array(
						'min' => -100,
						'max' => 100,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel.date_boxed .consulting-posts-carousel-wrapper .posts-item .posts-item-date-wrapper'   => 'left: {{SIZE}}{{UNIT}};',
					'{{WRAPPER}} .consulting-posts-carousel.date_boxed_2 .consulting-posts-carousel-wrapper .posts-item .posts-item-date-wrapper' => 'left: {{SIZE}}{{UNIT}};',
				),
				'condition'  => array(
					'posts_style' => array( 'date_boxed', 'date_boxed_2' ),
				),
			)
		);

		$this->add_responsive_control(
			'datebox_vertical_position',
			array(
				'label'      => __( 'Date Box Vertical Position', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'em', 'rem', 'custom' ),
				'range'      => array(
					'px'  => array(
						'min'  => -500,
						'max'  => 500,
						'step' => 1,
					),
					'em'  => array(
						'min' => -100,
						'max' => 100,
					),
					'rem' => array(
						'min' => -100,
						'max' => 100,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel.date_boxed .consulting-posts-carousel-wrapper .posts-item .posts-item-date-wrapper'   => 'bottom: {{SIZE}}{{UNIT}};',
					'{{WRAPPER}} .consulting-posts-carousel.date_boxed_2 .consulting-posts-carousel-wrapper .posts-item .posts-item-date-wrapper' => 'bottom: {{SIZE}}{{UNIT}};',
				),
				'condition'  => array(
					'posts_style' => array( 'date_boxed', 'date_boxed_2' ),
				),
			)
		);

		$this->add_responsive_control(
			'date_margin',
			array(
				'label'      => __( 'Margin', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-date' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
				'condition'  => array(
					'posts_style' => array( 'minimalistic' ),
				),
				'separator'  => 'after',
			)
		);

		$this->add_control(
			'date_icon',
			array(
				'label'       => esc_html__( 'Icon', 'consulting-elementor-widgets' ),
				'type'        => \Elementor\Controls_Manager::ICONS,
				'skin'        => 'inline',
				'default'     => array(
					'value'   => 'stm-clock',
					'library' => 'stm_library',
				),
				'label_block' => false,
				'condition'   => array(
					'posts_style!' => array( 'date_boxed', 'date_boxed_2', 'full_image', 'overlay_image', 'minimalistic' ),
				),
			)
		);

		$this->add_control(
			'date_icon_color',
			array(
				'label'     => __( 'Icon Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-date i'   => 'color: {{VALUE}}',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-date svg' => 'fill: {{VALUE}}',
				),
				'condition' => array(
					'posts_style!' => array( 'date_boxed', 'date_boxed_2', 'full_image', 'overlay_image', 'minimalistic' ),
				),
			)
		);

		$this->add_control(
			'date_icon_hover_color',
			array(
				'label'     => __( 'Icon Hover Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item:hover .posts-item-date i'   => 'color: {{VALUE}}',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item:hover .posts-item-date svg' => 'fill: {{VALUE}}',
				),
				'condition' => array(
					'posts_style!' => array( 'date_boxed', 'date_boxed_2', 'full_image', 'overlay_image', 'minimalistic' ),
				),
			)
		);

		$this->add_responsive_control(
			'date_icon_size',
			array(
				'label'      => __( 'Icon Size', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'em', 'rem', 'custom' ),
				'range'      => array(
					'px'  => array(
						'min'  => 0,
						'max'  => 100,
						'step' => 1,
					),
					'em'  => array(
						'min' => 0,
						'max' => 100,
					),
					'rem' => array(
						'min' => 0,
						'max' => 100,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-date i'   => 'font-size: {{SIZE}}{{UNIT}};',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-date svg' => 'width: {{SIZE}}{{UNIT}}; height: {{SIZE}}{{UNIT}};',
				),
				'condition'  => array(
					'posts_style!' => array( 'date_boxed', 'date_boxed_2', 'full_image', 'overlay_image', 'minimalistic' ),
				),
			)
		);

		$this->add_responsive_control(
			'date_icon_space',
			array(
				'label'      => __( 'Icon Spacing', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'em', 'rem', 'custom' ),
				'range'      => array(
					'px'  => array(
						'min'  => 0,
						'max'  => 100,
						'step' => 1,
					),
					'em'  => array(
						'min' => 0,
						'max' => 100,
					),
					'rem' => array(
						'min' => 0,
						'max' => 100,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-date' => 'gap: {{SIZE}}{{UNIT}};',
				),
				'condition'  => array(
					'posts_style!' => array( 'date_boxed', 'date_boxed_2', 'full_image', 'overlay_image', 'minimalistic' ),
				),
			)
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'image_section',
			array(
				'label' => __( 'Image', 'consulting-elementor-widgets' ),
				'tab'   => Controls_Manager::TAB_STYLE,
				'condition' => array(
					'show_image' => 'show',
				),
			)
		);

		$this->add_control(
			'image_size',
			array(
				'label'       => __( 'Image Size', 'consulting-elementor-widgets' ),
				'type'        => \Elementor\Controls_Manager::TEXT,
				'description' => __( 'Enter image size. Example: "thumbnail", "medium", "large", "full" or other sizes defined by current theme. Alternatively enter image size in pixels: 200x100 (Width x Height). Leave empty to use default size.', 'consulting-elementor-widgets' ),
				'default'     => 'full',
			)
		);

		$this->add_control(
			'image_size_2',
			array(
				'label'       => __( 'Image Size', 'consulting-elementor-widgets' ),
				'type'        => \Elementor\Controls_Manager::TEXT,
				'description' => __( 'Enter image size. Example: "thumbnail", "medium", "large", "full" or other sizes defined by current theme. Alternatively enter image size in pixels: 200x100 (Width x Height). Leave empty to use default size.', 'consulting-elementor-widgets' ),
				'condition' => array(
					'posts_style' => array( 'list', 'side_image' ),
				),
			)
		);

		$this->add_group_control(
			\Elementor\Group_Control_Background::get_type(),
			array(
				'name'      => 'image_overlay_color',
				'label'     => __( 'Overlay Color', 'consulting-elementor-widgets' ),
				'types'     => array( 'classic', 'gradient', 'video' ),
				'selector'  => '{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-inner-wrapper:before',
				'condition' => array(
					'posts_style' => array( 'full_image', 'overlay_image' ),
				),
			)
		);

		$this->add_responsive_control(
			'image_border_radius',
			array(
				'label'      => __( 'Image Border Radius', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-image img' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .posts-item .posts-item-inner-wrapper:before' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					'{{WRAPPER}} .consulting-posts-carousel.date_boxed_2 .consulting-posts-carousel-wrapper .posts-item .posts-item-image-wrapper:before' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
					'{{WRAPPER}} .consulting-posts-carousel.date_boxed_2 .consulting-posts-carousel-wrapper .posts-item .posts-item-image' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'navigation_section',
			array(
				'label' => __( 'Navigation', 'consulting-elementor-widgets' ),
				'tab'   => Controls_Manager::TAB_STYLE,
			)
		);

		$this->add_control(
			'navigation_prev_icon',
			array(
				'label'       => esc_html__( 'Previous Icon', 'consulting-elementor-widgets' ),
				'type'        => \Elementor\Controls_Manager::ICONS,
				'skin'        => 'inline',
				'default'     => array(
					'value'   => 'fas fa-chevron-left',
					'library' => 'fa-solid',
				),
				'label_block' => false,
			)
		);

		$this->add_control(
			'navigation_next_icon',
			array(
				'label'       => esc_html__( 'Next Icon', 'consulting-elementor-widgets' ),
				'type'        => \Elementor\Controls_Manager::ICONS,
				'skin'        => 'inline',
				'default'     => array(
					'value'   => 'fas fa-chevron-right',
					'library' => 'fa-solid',
				),
				'label_block' => false,
			)
		);

		$this->add_responsive_control(
			'navigation_size',
			array(
				'label'      => __( 'Icon Size', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'em', 'rem', 'custom' ),
				'range'      => array(
					'px'  => array(
						'min'  => 0,
						'max'  => 100,
						'step' => 1,
					),
					'em'  => array(
						'min' => 0,
						'max' => 100,
					),
					'rem' => array(
						'min' => 0,
						'max' => 100,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav svg' => 'width: {{SIZE}}{{UNIT}}; height: {{SIZE}}{{UNIT}};',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav i'   => 'font-size: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'navigation_background_size',
			array(
				'label'      => __( 'Background Size', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'em', 'rem', 'custom' ),
				'range'      => array(
					'px'  => array(
						'min'  => 0,
						'max'  => 200,
						'step' => 1,
					),
					'em'  => array(
						'min' => 0,
						'max' => 200,
					),
					'rem' => array(
						'min' => 0,
						'max' => 200,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav .slick-prev, {{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav .slick-next' => 'width: {{SIZE}}{{UNIT}}; height: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'navigation_color',
			array(
				'label'     => __( 'Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav svg' => 'fill: {{VALUE}}',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav i'   => 'color: {{VALUE}}',
				),
			)
		);

		$this->add_control(
			'navigation_hover_color',
			array(
				'label'     => __( 'Hover Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav .slick-prev:hover svg, {{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav .slick-next:hover svg' => 'fill: {{VALUE}}',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav .slick-prev:hover i, {{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav .slick-next:hover i'     => 'color: {{VALUE}}',
				),
			)
		);

		$this->add_control(
			'navigation_bg_color',
			array(
				'label'     => __( 'Background Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav .slick-prev, {{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav .slick-next' => 'background-color: {{VALUE}}',
				),
			)
		);

		$this->add_control(
			'navigation_bg_hover_color',
			array(
				'label'     => __( 'Background Hover Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav .slick-prev:hover, {{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav .slick-next:hover' => 'background-color: {{VALUE}}',
				),
			)
		);

		$this->add_control(
			'navigation_border_color',
			array(
				'label'     => __( 'Border Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav .slick-prev, {{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav .slick-next' => 'border-color: {{VALUE}}',
				),
			)
		);

		$this->add_control(
			'navigation_border_hover_color',
			array(
				'label'     => __( 'Border Hover Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav .slick-prev:hover, {{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav .slick-next:hover' => 'border-color: {{VALUE}}',
				),
			)
		);

		$this->add_group_control(
			\Elementor\Group_Control_Border::get_type(),
			array(
				'name'     => 'navigation_border',
				'selector' => '{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav .slick-prev, {{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav .slick-next',
				'exclude'  => array( 'color' ),
			)
		);

		$this->add_control(
			'navigation_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav .slick-prev, {{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-nav .slick-next' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'pagination_section',
			array(
				'label' => __( 'Pagination', 'consulting-elementor-widgets' ),
				'tab'   => Controls_Manager::TAB_STYLE,
			)
		);

		$this->add_control(
			'pagination_color',
			array(
				'label'     => __( 'Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .slick-dots li button' => 'background-color: {{VALUE}}',
				),
			)
		);

		$this->add_control(
			'pagination_active_color',
			array(
				'label'     => __( 'Active Color', 'consulting-elementor-widgets' ),
				'type'      => \Elementor\Controls_Manager::COLOR,
				'selectors' => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .slick-dots li.slick-active button, {{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .slick-dots li:hover button' => 'background-color: {{VALUE}}',
				),
			)
		);

		$this->add_responsive_control(
			'dots_width',
			array(
				'label'      => __( 'Dots Width', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'em', 'rem', 'custom' ),
				'range'      => array(
					'px'  => array(
						'min'  => 0,
						'max'  => 100,
						'step' => 1,
					),
					'em'  => array(
						'min' => 0,
						'max' => 100,
					),
					'rem' => array(
						'min' => 0,
						'max' => 100,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .slick-dots button' => 'width: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'dots_width_active',
			array(
				'label'      => __( 'Dots Width Active', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'em', 'rem', 'custom' ),
				'range'      => array(
					'px'  => array(
						'min'  => 0,
						'max'  => 100,
						'step' => 1,
					),
					'em'  => array(
						'min' => 0,
						'max' => 100,
					),
					'rem' => array(
						'min' => 0,
						'max' => 100,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .slick-dots li.slick-active button' => 'width: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'dots_height',
			array(
				'label'      => __( 'Dots Height', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'em', 'rem', 'custom' ),
				'range'      => array(
					'px'  => array(
						'min'  => 0,
						'max'  => 100,
						'step' => 1,
					),
					'em'  => array(
						'min' => 0,
						'max' => 100,
					),
					'rem' => array(
						'min' => 0,
						'max' => 100,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .slick-dots li button' => 'height: {{SIZE}}{{UNIT}};',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .slick-dots'           => 'min-height: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_responsive_control(
			'dots_height_active',
			array(
				'label'      => __( 'Dots Height Active', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::SLIDER,
				'size_units' => array( 'px', 'em', 'rem', 'custom' ),
				'range'      => array(
					'px'  => array(
						'min'  => 0,
						'max'  => 100,
						'step' => 1,
					),
					'em'  => array(
						'min' => 0,
						'max' => 100,
					),
					'rem' => array(
						'min' => 0,
						'max' => 100,
					),
				),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .slick-dots li.slick-active button' => 'height: {{SIZE}}{{UNIT}};',
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .slick-dots'                        => 'min-height: {{SIZE}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'pagination_border_radius',
			array(
				'label'      => esc_html__( 'Border Radius', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .slick-dots li button' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->add_control(
			'pagination_border_radius_active',
			array(
				'label'      => esc_html__( 'Border Radius Active', 'consulting-elementor-widgets' ),
				'type'       => \Elementor\Controls_Manager::DIMENSIONS,
				'size_units' => array( 'px', '%', 'em', 'rem', 'custom' ),
				'selectors'  => array(
					'{{WRAPPER}} .consulting-posts-carousel .consulting-posts-carousel-wrapper .slick-dots li.slick-active button' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
				),
			)
		);

		$this->end_controls_section();

		$this->add_dimensions( '.consulting-posts-carousel' );
	}

	protected function render() {
		$settings          = $this->get_settings_for_display();
		$settings['query'] = Consulting_Elementor_Widgets::get_query_builder( $settings, 'qb' );

		$settings['carousel_settings']  = ' data-navigation="' . $settings['show_navigation'] . '"';
		$settings['carousel_settings'] .= ' data-pagination="' . $settings['show_pagination'] . '"';
		$settings['carousel_settings'] .= ' data-autoplay="' . $settings['carousel_autoplay'] . '"';
		$settings['carousel_settings'] .= isset( $settings['carousel_autoplay_speed'] ) && 0 < $settings['carousel_autoplay_speed'] ? ' data-autoplay-speed="' . $settings['carousel_autoplay_speed'] . '"' : ' data-autoplay-speed="5000"';
		$settings['carousel_settings'] .= ' data-lazyload="' . $settings['carousel_lazyload'] . '"';
		$settings['carousel_settings'] .= ' data-pause-hover="' . $settings['carousel_pause_on_hover'] . '"';
		$settings['carousel_settings'] .= ' data-pause-interaction="' . $settings['carousel_pause_on_interaction'] . '"';
		$settings['carousel_settings'] .= ' data-infinite="' . $settings['carousel_infinite'] . '"';
		$settings['carousel_settings'] .= ' data-type="' . $settings['carousel_type'] . '"';

		$settings['css_style']  = '';
		$settings['css_style'] .= ! empty( $settings['posts_style'] ) ? $settings['posts_style'] : '';
		$settings['css_style'] .= ! empty( $settings['carousel_type'] ) ? ' carousel-type-' . $settings['carousel_type'] : ' carousel-type-default';
		$settings['css_style'] .= ! empty( $settings['full_width_no_spacing'] ) && 'yes' === $settings['full_width_no_spacing'] ? ' no_spacing' : '';
		$settings['css_style'] .= ! empty( $settings['navigation_position'] ) ? ' navigation-position-' . $settings['navigation_position'] : ' navigation-position-separate';
		$settings['css_style'] .= ! empty( $settings['navigation_together_vertical_position'] ) ? ' navigation-together-vertical-position-' . $settings['navigation_together_vertical_position'] : ' navigation-together-vertical-position-top';
		$settings['css_style'] .= ! empty( $settings['navigation_together_horizontal_position'] ) ? ' navigation-together-horizontal-position-' . $settings['navigation_together_horizontal_position'] : ' navigation-together-horizontal-position-left';
		$settings['css_style'] .= ! empty( $settings['pagination_alignment'] ) ? ' pagination-alignment-' . $settings['pagination_alignment'] : ' pagination-alignment-center';

		stm_load_variations_template( $settings, '/posts-carousel/styles/' . sanitize_file_name( $settings['posts_style'] ) );
	}
}
