<?php

$image_size = ! empty( $settings['image_size'] ) ? $settings['image_size'] : '350x230';

$carousel_id = uniqid( 'posts-carousel-' );

$title_css  = 'none' !== $settings['show_title_line'] ? 'title-line-' . $settings['show_title_line'] : 'title-line-none';
$title_css .= ! empty( $settings['title_alignment_left'] ) ? ' title-alignment-' . $settings['title_alignment_left'] : ' title-alignment-left';

$category_css = ! empty( $settings['category_alignment_left'] ) ? ' category-alignment-' . $settings['category_alignment_left'] : ' category-alignment-left';

if ( $settings['query']->have_posts() ) {
	?>
	<div class="consulting-posts-carousel <?php echo esc_attr( $settings['css_style'] ); ?>">
		<div class="consulting-posts-carousel-wrapper" <?php echo wp_kses_post( $settings['carousel_settings'] ); ?> data-columns="<?php echo esc_attr( $settings['posts_per_row'] ); ?>" data-id="<?php echo esc_attr( $carousel_id ); ?>">
			<?php
			while ( $settings['query']->have_posts() ) {
				$settings['query']->the_post();
				$post_terms = get_post_terms( get_the_ID(), get_post_type(), ', ', 1 );
				?>
				<div class="posts-item">
					<div class="posts-item-inner">
						<?php
						if ( 'show' === $settings['show_image'] && has_post_thumbnail() ) {
							?>
							<div class="posts-item-image">
								<a href="<?php the_permalink(); ?>">
								<?php
								$author_photo = consulting_get_image( get_post_thumbnail_id(), $image_size );
								echo wp_kses_post( consulting_filtered_output( $author_photo ) );
								?>
								</a>
							</div>
							<?php
						}
						?>

						<div class="posts-item-info">
							<h5 class="posts-item-title <?php echo esc_attr( $title_css ); ?>">
								<a href="<?php the_permalink(); ?>"><?php the_title(); ?></a>
							</h5>
							<?php
							if ( 'show' === $settings['show_category'] ) {
								?>
								<div class="posts-item-category <?php echo esc_attr( $category_css ); ?>">
									<?php echo wp_kses_post( $post_terms ); ?>
								</div>
									<?php
							}
							if ( 'show' === $settings['show_excerpt'] ) {
								?>
								<div class="posts-item-excerpt">
									<?php
									$excerpt_limit = $settings['excerpt_length'] ?? 0;
									echo esc_html( Consulting_Elementor_Widgets::custom_excerpt_length( get_the_excerpt(), $excerpt_limit ) );
									?>
								</div>
									<?php
							}
							?>
							<div class="posts-item-bottom">
								<?php
								if ( 'show' === $settings['show_date'] ) {
									?>
									<div class="posts-item-date-wrapper">
										<span class="posts-item-date">
											<?php
											\Elementor\Icons_Manager::render_icon(
												$settings['date_icon'],
												array(
													'class' => 'date-icon',
												)
											);
											echo get_the_date( 'M j, Y' );
											?>
										</span>
									</div>
									<?php
								}
								if ( 'show' === $settings['show_button'] ) {
									?>
									<a href="<?php the_permalink(); ?>" class="posts-item-button <?php echo 'icon-position-' . esc_attr( $settings['button_icon_position'] ); ?>">
										<span class="button-text">
											<?php
											echo esc_html( $settings['button_text'] );
											?>
										</span>
										<?php
										\Elementor\Icons_Manager::render_icon(
											$settings['button_icon'],
											array(
												'class' => 'button-icon',
											)
										);
										?>
									</a>
									<?php
								}
								?>
							</div>
						</div>
					</div>
				</div>
				<?php
			}
			?>
		</div>
		<?php
		if ( 'yes' === $settings['show_navigation'] ) {
			?>
			<div class="slick-navs consulting-posts-carousel-nav">
				<div class="slick-prev slick-prev-extra">
					<?php
					\Elementor\Icons_Manager::render_icon(
						$settings['navigation_prev_icon'],
						array(
							'class' => 'navigation-icon',
						)
					);
					?>
				</div>
				<div class="slick-next slick-next-extra">
					<?php
					\Elementor\Icons_Manager::render_icon(
						$settings['navigation_next_icon'],
						array(
							'class' => 'navigation-icon',
						)
					);
					?>
				</div>
			</div>
			<?php
		}
		?>
	</div>
	<?php
}
wp_reset_postdata();
